=== debian/changelog ===
libpstat (0.3-1+genuen6u1) unstable; urgency=medium

  * Build for escalibur

 -- Aitor <aitor@genuen.org>  Sat, 20 Dec 2025 19:14:23 +0100

libpstat (0.3-1) unstable; urgency=medium

  * Add some new functions for external use.
  * Fix lintian errors and warnings
  * New upstream version 0.3

 -- Aitor <aitor@genuen.org>  Sun, 09 Jul 2023 11:57:32 +0200

libpstat (0.2-1) unstable; urgency=medium

  * Bugfix: move the definition of PREFIX above the definition of LIB in
    the Makefile
  * Include missing libpstat.pc file
  * New upstream 0.2

 -- Aitor <aitor@genuen.org>  Wed, 14 Dec 2022 22:37:04 +0100

libpstat (0.1-1) chimaera; urgency=medium

  * Build for chimaera

 -- Aitor <aitor@genuen.org>  Tue, 02 Nov 2021 00:43:51 +0100
