=== debian/control ===
Source: libpstat
Section: admin
Priority: optional
Maintainer: Aitor <aitor@genuen.org>
Uploaders: Jude Nelson <judecn@devuan.org>
Standards-Version: 4.5.1
Origin: Genuen
Homepage: http://judecnelson.blogspot.com
XS-Testsuite: autopkgtest
Build-Depends: debhelper (>= 12), dh-exec, fakeroot, libc6-dev (>= 2.31-13~)

Package: libpstat1
Section: libs
Priority: optional
Architecture: linux-any
Multi-Arch: same
Conflicts: libpstat
Replaces: libpstat
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Proccess status library.
 libpstat is a small library for getting information on running processes in
 an OS-agnostic way. The source is structured to make it easy to add support
 for additional operating systems. Currently, Linux is the only supported OS.

Package: libpstat-dev
Section: libdevel
Priority: optional
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libpstat1 (= ${binary:Version})
Description: Process status library development files.
 libpstat is a small library for getting information on running processes in
 an OS-agnostic way. The source is structured to make it easy to add support
 for additional operating systems. Currently, Linux is the only supported OS.

Package: libpstat-util
Section: utils
Priority: optional
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libpstat1 (= ${binary:Version})
Description: Process status library utilities.
 libpstat is a small library for getting information on running processes in
 an OS-agnostic way. The source is structured to make it easy to add support
 for additional operating systems. Currently, Linux is the only supported OS.
